#include <bits/stdc++.h>

using namespace std;

int main(){
int pacijenti, O, A,jedinica;
char opis;
cin >> pacijenti;
cin >> O >> A;
int ispisO = 10,ispisA = 01;
int zbir = O + A;
for(int i = 0;i < pacijenti;i++){
    cin >> opis >> jedinica;
    if(opis == 'O' && jedinica > O){
        cout << "nemoguce" << endl;
        return 0;
    }
    if(O + A < jedinica){
        cout << "nemoguce" << endl;
        return 0;
    }
    if(opis == 'O'){
        O -= jedinica;
        cout << jedinica << "0" << endl;
        }
    if(opis == 'A' && jedinica > A){
        cout << (A - jedinica)*-1 << A << endl;
        O = O - (A - jedinica)*-1;
    }
    if(opis == 'A' && jedinica <= A){
        A -= jedinica;
        cout << "0" << jedinica << endl;
        }
}
return 0;
}